﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Text


Public Class clsMessage

    Private _From As String = String.Empty    '誰から
    Private _To As String = String.Empty    '誰に
    Private _Key As String = String.Empty    'Key
    Private _Value As String = String.Empty    '値
    Private _SpecialKey As Boolean = False    '特殊な値か。KeyのNGチェックを無視する

    ''' <summary>
    ''' 送信元を識別する名前
    ''' </summary>
    Public Property ReceiveFrom() As String
        Get
            Return _From
        End Get
        Set(ByVal value As String)
            If Not clsCommon.nameCheck(value) Then
                Throw New NotUsableNameException(value)
            End If
            _From = value
        End Set
    End Property

    ''' <summary>
    ''' 送信先を識別する名前
    ''' </summary>
    Public Property SendTo() As String
        Get
            Return _To
        End Get
        Set(ByVal value As String)
            If Not clsCommon.nameCheck(value) Then
                Throw New NotUsableNameException(value)
            End If
            _To = value
        End Set
    End Property

    ''' <summary>
    ''' プロトコルとなるキーワード
    ''' </summary>
    Public Property Key() As String
        Get
            Return _Key
        End Get
        Set(ByVal value As String)
            'SpecialKeyではなく、keyチェックNGの場合は例外スロー
            If Not SpecialKey AndAlso Not clsCommon.keyCheck(value) Then
                Throw New NotUsableKeyException(value)
            End If
            _Key = value
        End Set
    End Property

    ''' <summary>
    ''' 送りたい値
    ''' </summary>
    Public Property Value() As String
        Get
            Return _Value
        End Get
        Set(ByVal value As String)
            _Value = value
        End Set
    End Property

    ''' <summary>
    ''' SpecialKeyを送信する場合にあらかじめ設定する。
    ''' Keyを入力する際のチェックがなくなる。
    ''' </summary>
    Friend Property SpecialKey() As Boolean
        Get
            Return _SpecialKey
        End Get
        Set(ByVal value As Boolean)
            _SpecialKey = value
        End Set
    End Property

    Public Overrides Function ToString() As String
        Return clsCommon.GetStringFromBytes(clsCommon.GetBytesFromMessage(Me))
    End Function

    ''' <summary>
    ''' ログに書き出すときとかにどうぞ。
    ''' </summary>
    ''' <returns></returns>
    Public Function ToStringForView() As String
        Dim sb As New StringBuilder()
        sb.Append("[" & Me.SpecialKey.ToString() & "]")
        sb.Append("(" & clsCommon.GetSameLengthString(Me.ReceiveFrom, 12) & " -> ")
        sb.Append("" & clsCommon.GetSameLengthString(Me.SendTo, 12) & ")")
        sb.Append(" [" & Me.Key & "]")
        sb.Append("" & Me.Value)
        Return sb.ToString()
    End Function

End Class

Public Class NotUsableKeyException
    Inherits Exception
    Public Sub New(ByVal key As String)
        MyBase.New(("このKeyは使えません。[" & key & "]" & vbCr & vbLf & vbCr & vbLf & "1.[") + clsConst.SEPALETER & "]を含んではいませんか？" & vbCr & vbLf & "2.定義済みの文字列を使用している可能性があります。" & vbCr & vbLf & "他の文字列に変えてみてください。")
    End Sub
End Class

Public Class NotUsableNameException
    Inherits Exception
    Public Sub New(ByVal name As String)
        MyBase.New(("このNameは使えません。[" & name & "]" & vbCr & vbLf & vbCr & vbLf & "1.[") + clsConst.SEPALETER & "]を含んではいませんか？")
    End Sub
End Class
